/*
 * Purpose: Sample application for demonstrating and testing the wxWindows email support
 * Author:  Frank Bu
 * Created: 2002
 */

#ifndef SNDDLG_H
#define SNDDLG_H

#include <wx/wx.h>
#include <wx/listctrl.h>

#include "smtp.h"

class WinoDialog;

/**
 * Define the one and only dialog for this application.
 */
class SendDialog : public wxDialog, public wxSMTPListener
{
public:
	/**
	 * Setup the dialog controls and center the dialog.
	 */
    SendDialog(WinoDialog& winoDialog);

	virtual ~SendDialog();

	/**
	 * wxSMTPListener interface: Is called if an error occured (not implemented).
	 */
	void OnSocketError(int errorCode);

	/**
	 * wxSMTPListener interface: Is called if the server acknowleded a recipient.
	 */
	void OnRecipientAdded(const wxString& address, int errorCode);

	/**
	 * wxSMTPListener interface: Is called if the server acknowleded the email text was sent.
	 */
	void OnDataSent(int errorCode);

private:
	wxSMTP* m_pSMTP;
	wxEmailMessage* m_pMessage;

	wxStaticText* m_pStatusText;
	wxStaticText* m_pEmailCountText;
	wxStaticText* m_pEmailSuccessText;
	wxTextCtrl* m_pLogTextCtrl;

	size_t m_successCount;

	DECLARE_EVENT_TABLE()
};


#endif
