/*
 * Purpose: Sample application for demonstrating and testing the wxWindows email support
 * Author:  Frank Bu
 * Created: 2002
 */

#ifndef WINO_H
#define WINO_H

#include <wx/wx.h>
#include <wx/listctrl.h>

#if !defined(__WXMSW__)
extern char* wino_xpm[];
#endif

/**
 * Define the Wino (Wino Is Not Outlook) application type.
 */
class WinoApp : public wxApp
{
public:
	/**
	 * Shows the WinoDialog and return false, for terminating the program
	 * after closing the modal dialog.
	 * \return false.
	 */
    bool OnInit();
};

/**
 * Define the one and only dialog for this application.
 */
class WinoDialog : public wxDialog
{
public:
	/**
	 * Setup the dialog controls and center the dialog.
	 */
    WinoDialog(wxWindow *parent);
	~WinoDialog();

	/**
	 * Sends the email.
	 */
	void OnSendButton(wxCommandEvent &event);

	/**
	 * Adds an file attachment.
	 */
	void OnFileAddButton(wxCommandEvent &event);

	/**
	 * Removes the currently selected file attachment.
	 */
	void OnFileRemoveButton(wxCommandEvent &event);

	/**
	 * Adds a Address Manager database.
	 */
	void OnAddressAddButton(wxCommandEvent &event);

	/**
	 * Removes the currently selected Address Manager database.
	 */
	void OnAddressRemoveButton(wxCommandEvent &event);

private:
	wxTextCtrl* m_pServerTextCtrl;
	wxTextCtrl* m_pFromTextCtrl;
	wxTextCtrl* m_pToTextCtrl;
	wxTextCtrl* m_pSubjectTextCtrl;
	wxTextCtrl* m_pTextTextCtrl;
	wxListBox* m_pFilelist;
	wxListBox* m_pAddresslist;

	DECLARE_EVENT_TABLE()

	friend class SendDialog;
};


#endif
